import pandas as pd
import numpy as np
import datetime
import time, datetime
import scipy
import math
import itertools
import log
from scipy.signal import savgol_filter
from scipy import interpolate
from sklearn.linear_model import LinearRegression
from LIB.MIDDLE.CellStateEstimation.Common.V1_0_1 import BatParam

class sor_est:
    def __init__(self,sn,celltype,df_bms):  #参数初始化

        self.sn=sn
        self.celltype=celltype
        self.param=BatParam.BatParam(celltype)#鹏飞param中为BatParam，学琦为BatteryInfo
        self.df_bms=pd.DataFrame(df_bms)
        self.packcrnt=df_bms['总电流[A]']*self.param.PackCrntDec
        self.packvolt=df_bms['总电压[V]']
        self.bms_soc=df_bms['SOC[%]']
        self.bmstime= pd.to_datetime(df_bms['时间戳'], format='%Y-%m-%d %H:%M:%S')
        self.LookTab_OCV = self.param.LookTab_OCV
        self.LookTab_SOC = self.param.LookTab_SOC
        
        self.cellvolt_list=['单体电压'+str(x) for x in range(1,self.param.CellVoltNums+1)]
        self.celltemp_name=['单体温度'+str(x) for x in range(1,self.param.CellTempNums+1)]
        self.bmssta = df_bms['充电状态']
    #定义加权滤波函数..................................................................................................
    def moving_average(interval, windowsize):
        window = np.ones(int(windowsize)) / float(windowsize)
        re = np.convolve(interval, window, 'same')
        return re
    
#.............................................内阻及电压估计............................................................................
    def sor_cal(self):
        #定义Rint模型计算内阻函数----------------------------------------------
        def sor_cal_prog(input_data):
            # cellvolt_name = self.cellvolt_list#电芯数量
            # celltemp_name = self.celltemp_name#电芯温度数量
            # LookTab_OCV = self.LookTab_OCV
            # LookTab_SOC = self.LookTab_SOC
            # max_volt = max(LookTab_OCV)
            # min_volt = min(LookTab_OCV)
            # soc_interplt = interpolate.interp1d(LookTab_OCV, LookTab_SOC, kind = 'linear')#OCV-SOC插值函数
            df_sor_result_cal = pd.DataFrame(columns = ["sn", "time", "sor", "sor_sigma", "soc", "temp", "delta_time"])
            np_crnt_num = np.sum(input_data['总电流[A]'] != 0)#计算所选数据中非零值个数
            if np_crnt_num > 10:#放电中无电流过多数据时不计算阻值
                sor_temp = []
                df_sor_time = pd.to_datetime(input_data['时间戳'])
                df_sor_soc_data = input_data.iloc[0]#静置最后时刻数据，计算SOC用
                delta_time_sor = round((df_sor_time.iloc[-1] - df_sor_time.iloc[0])/pd.Timedelta(1, 'min'), 3)#计算内阻使用数据段的时长
                df_soc_volt = df_sor_soc_data[cellvolt_name]/1000
                df_soc_volt[df_soc_volt > max_volt] = max_volt - 0.0005
                df_soc_volt[df_soc_volt < min_volt] = min_volt + 0.0005
                df_soc_temp = soc_interplt(list(df_soc_volt))#插值计算电芯SOC
                df_soc = [round(i, 3) for i in df_soc_temp]
                df_sor_volt = input_data[cellvolt_name]/1000
                df_sor_crnt = input_data['总电流[A]']
                df_sorvolt_dif = np.diff(df_sor_volt, axis = 0)
                df_sorcrnt_dif = np.diff(df_sor_crnt, axis = 0)
                df_sorvolt_dif_csv = pd.DataFrame(df_sorvolt_dif)
                df_sorvolt_dif_csv.columns = cellvolt_name
                df_sor_volt_csv = pd.DataFrame(df_sor_volt)
                df_sor_volt_csv.columns = cellvolt_name
                if np.sum(df_sor_crnt != 0) > 0.3*len(df_sorcrnt_dif):
                    if np.sum(df_sorcrnt_dif != 0) > 0.2*len(df_sorcrnt_dif):
                        for item in cellvolt_name:
                            lineModel = LinearRegression()
                            lineModel.fit(np.array(df_sorcrnt_dif).reshape(-1, 1), df_sorvolt_dif_csv[item])
                            sor_temp.append(1000*lineModel.coef_[0])
                            sor_temp_formt = [round(i, 3) for i in sor_temp]
                        sor_sort_temp = np.sort(sor_temp)
                        sor_sort_del = sor_sort_temp[1:-2]
                        sor_sort_del_mean = np.mean(sor_sort_del)#去除最值的均值
                        sor_sort_del_std = np.std(sor_sort_del)#去除最值的均方差
                        sor_sigma_temp = list((sor_temp - sor_sort_del_mean)/sor_sort_del_std)
                        sor_sigma = [round(i, 3) for i in sor_sigma_temp]
                        df_sor_result_cal = pd.DataFrame({"sn":[self.sn], "time":[input_data['时间戳'].iloc[0]], "sor":[str(sor_temp_formt)], "sor_sigma":[str(sor_sigma)],
                                                                "soc":[str(list(df_soc))], "temp":[str(list(input_data[celltemp_name].iloc[0]))], "delta_time":[delta_time_sor]})
                if np.sum(df_sor_crnt != 0) > 0.6*len(df_sorcrnt_dif):
                    if np.sum(df_sorcrnt_dif != 0) < 0.05*len(df_sorcrnt_dif):
                        for item in cellvolt_name:
                            sor_item = (df_sor_volt_csv[item].iloc[0] - df_sor_volt_csv[item].iloc[-1])/np.mean(df_sor_crnt)
                            sor_temp.append(1000*sor_item)
                            sor_temp_formt = [round(i, 3) for i in sor_temp]
                        sor_sort_temp = np.sort(sor_temp)
                        sor_sort_del = sor_sort_temp[1:-2]
                        sor_sort_del_mean = np.mean(sor_sort_del)#去除最值的均值
                        sor_sort_del_std = np.std(sor_sort_del)#去除最值的均方差
                        sor_sigma_temp = list((sor_temp - sor_sort_del_mean)/sor_sort_del_std)
                        sor_sigma = [round(i, 3) for i in sor_sigma_temp]
                        df_sor_result_cal = pd.DataFrame({"sn":[self.sn], "time":[input_data['时间戳'].iloc[0]], "sor":[str(sor_temp_formt)], "sor_sigma":[str(sor_sigma)],
                                                                "soc":[str(list(df_soc))], "temp":[str(list(input_data[celltemp_name].iloc[0]))], "delta_time":[delta_time_sor]})
            return df_sor_result_cal
        start_time = time.time()
        cellvolt_name = self.cellvolt_list#电芯数量
        celltemp_name = self.celltemp_name#电芯温度数量
        LookTab_OCV = self.LookTab_OCV
        LookTab_SOC = self.LookTab_SOC
        max_volt = max(LookTab_OCV)
        min_volt = min(LookTab_OCV)
        soc_interplt = interpolate.interp1d(LookTab_OCV, LookTab_SOC, kind = 'linear')#OCV-SOC插值函数
        data = self.df_bms
        data.fillna(0, inplace=True)
        df_sor_result = pd.DataFrame(columns = ["sn", "time", "sor", "sor_sigma", "soc", "temp", "delta_time"])
        df_dschrg_data_temp = data.loc[data['充电状态'] == 3]#筛选放电数据
        df_dschrg_data = df_dschrg_data_temp.reset_index(drop = True)
        np_dschrg_time = pd.to_datetime(df_dschrg_data['时间戳'])
        dff_dschrg_time = np.diff(np_dschrg_time)/pd.Timedelta(1, 'min')#放电过程前后时间差
        rest_dschrg_pos = np.where(dff_dschrg_time > 30)#筛选前后时间差大于30min的位置及时间点,判断为两次放电  
        df_dschrg_time = pd.to_datetime(df_dschrg_data['时间戳'])
        df_origin_time = pd.to_datetime(data['时间戳'])
        k = 1
        if len(rest_dschrg_pos[0]) > 0:
            if len(np_dschrg_time) > 0:
                if rest_dschrg_pos[0][0] > 20:#首个放电过程采样点大于20
                    if (df_dschrg_time.iloc[0] - df_origin_time.iloc[0])/pd.Timedelta(1, 'min') > 30:#对比数据中行车数据与充电后静置开始时间，确认初始静置时间是否充足
                        df_rest_chrg_data_temp = data.loc[pd.to_datetime(data['时间戳']) < df_dschrg_time.iloc[0]]#筛选首次放电前的数据
                        df_rest_chrg_data = df_rest_chrg_data_temp.reset_index(drop = True)
                        df_zerocrnt_st_temp = df_rest_chrg_data.loc[df_rest_chrg_data['总电流[A]'] == 0]#电流为0的数据
                        df_zerocrnt_st = df_zerocrnt_st_temp.reset_index(drop = True)
                        df_nonzerocrnt_st_temp = df_rest_chrg_data.loc[df_rest_chrg_data['总电流[A]'] != 0]#电流非0的数据
                        df_nonzerocrnt_st = df_nonzerocrnt_st_temp.reset_index(drop = True)
                        df_time_zerocrnt = pd.to_datetime(df_zerocrnt_st['时间戳'])
                        df_time_nonzerocrnt = pd.to_datetime(df_nonzerocrnt_st['时间戳'])
                        if len(df_time_zerocrnt) != 0:
                            if len(df_time_nonzerocrnt) == 0:#均是静置
                                if (df_time_zerocrnt.iloc[-1] - df_time_zerocrnt.iloc[0])/pd.Timedelta(1, 'min') > 30:
                                    df_sor_cal = data.loc[(pd.to_datetime(data['时间戳']) >= df_origin_time.iloc[-1]) & (pd.to_datetime(data['时间戳']) < df_origin_time.iloc[-1] + datetime.timedelta(minutes = 15))]#筛选首次放电前的数据
                                    if len(df_sor_cal) > 20:
                                        df_sor_result_temp = sor_cal_prog(df_sor_cal)
                                        df_sor_result = df_sor_result.append(df_sor_result_temp)
                                        df_sor_result.reset_index(drop = True, inplace = True)
                            if len(df_time_nonzerocrnt) != 0:#存在充电
                                if (df_time_zerocrnt.iloc[-1] - df_time_nonzerocrnt.iloc[-1])/pd.Timedelta(1, 'min') > 30:
                                    df_sor_cal = data.loc[(pd.to_datetime(data['时间戳']) >= df_origin_time.iloc[-1]) & (pd.to_datetime(data['时间戳']) < df_origin_time.iloc[-1] + datetime.timedelta(minutes = 15))]#筛选首次放电前的数据
                                    if len(df_sor_cal) > 20:
                                        df_sor_result_temp = sor_cal_prog(df_sor_cal)
                                        df_sor_result = df_sor_result.append(df_sor_result_temp)
                                        df_sor_result.reset_index(drop = True, inplace = True)
                for item in range(0, len(rest_dschrg_pos[0]) - 1):#
                    #---------------------------------------------------判断放电数据是否足够计算-----------------------------------------------------------
                    if (rest_dschrg_pos[0][item + 1] - rest_dschrg_pos[0][item]) > 20:#判断数据点个数，数据点过少的不计算
                        #---------------------------------------------------判断静置时间是否充足--------------------------------------------------------------
                        df_rest_chrg_data_temp = data.loc[(pd.to_datetime(data['时间戳']) > df_dschrg_time.iloc[rest_dschrg_pos[0][item]]) & 
                                                        (pd.to_datetime(data['时间戳']) < df_dschrg_time.iloc[rest_dschrg_pos[0][item] + 1])]#筛选首次放电前的数据#筛选放电之间的数据段
                        df_rest_chrg_data = df_rest_chrg_data_temp.reset_index(drop = True)
                        df_zerocrnt_st_temp = df_rest_chrg_data.loc[df_rest_chrg_data['总电流[A]'] == 0]#电流为0的数据
                        df_zerocrnt_st = df_zerocrnt_st_temp.reset_index(drop = True)
                        df_nonzerocrnt_st_temp = df_rest_chrg_data.loc[df_rest_chrg_data['总电流[A]'] != 0]#电流非0的数据
                        df_nonzerocrnt_st = df_nonzerocrnt_st_temp.reset_index(drop = True)
                        df_time_zerocrnt = pd.to_datetime(df_zerocrnt_st['时间戳'])
                        df_time_nonzerocrnt = pd.to_datetime(df_nonzerocrnt_st['时间戳'])
                        st_caltime = time.time()
                        print('第' + str(k) + '个内阻计算')
                        k = k + 1
                        if (len(df_zerocrnt_st) != 0):
                            if ((df_time_zerocrnt.iloc[-1] - df_time_zerocrnt.iloc[0])/pd.Timedelta(1, 'min') > 30):#无电流最大最小时间差大于45分钟
                                if (len(df_nonzerocrnt_st) == 0):#放电前的静置过程无电流
                                    if df_dschrg_data['总电流[A]'].iloc[rest_dschrg_pos[0][item] + 1] != 0:#放电过程第一个数据的电流非0
                                        df_sor_cal = data.loc[(pd.to_datetime(data['时间戳']) >= df_time_zerocrnt.iloc[-1]) & (pd.to_datetime(data['时间戳']) < df_time_zerocrnt.iloc[-1] + datetime.timedelta(minutes = 15))]#筛选首次放电前的数据
                                        df_sor_result_temp = sor_cal_prog(df_sor_cal)
                                        df_sor_result = df_sor_result.append(df_sor_result_temp)
                                        df_sor_result.reset_index(drop = True, inplace = True)
                                    if df_dschrg_data['总电流[A]'].iloc[rest_dschrg_pos[0][item] + 1] == 0:#放电阶段首个采样时刻无电流时，需选取放电过程中有电流的时间段
                                        df_dschrg_item_temp = df_dschrg_data.iloc[(rest_dschrg_pos[0][item] + 1):rest_dschrg_pos[0][item + 1]]#放电数据
                                        df_dschrg_item = df_dschrg_item_temp.reset_index(drop = True)
                                        df_dschrg_crnt_data = df_dschrg_item.loc[df_dschrg_item['总电流[A]'] != 0]#有电流数据
                                        if len(df_dschrg_crnt_data) > 0:
                                            np_frst_crnt_pos = df_dschrg_crnt_data[df_dschrg_crnt_data['时间戳'] == df_dschrg_crnt_data['时间戳'].iloc[0]].index.tolist()#首个出现电流点
                                            np_frst_crnt_time = pd.to_datetime(df_dschrg_item['时间戳'].iloc[np_frst_crnt_pos[0] - 1])
                                            df_sor_cal = data.loc[(pd.to_datetime(data['时间戳']) >= np_frst_crnt_time) & (pd.to_datetime(data['时间戳']) < np_frst_crnt_time + datetime.timedelta(minutes = 15))]#筛选首次放电前的数据
                                            df_sor_result_temp = sor_cal_prog(df_sor_cal)
                                            df_sor_result = df_sor_result.append(df_sor_result_temp)
                                            df_sor_result.reset_index(drop = True, inplace = True)
                                if (len(df_nonzerocrnt_st) != 0):#有电流时需判断有电流的最后时刻与无电流的最后时刻的时间差
                                    if ((df_time_zerocrnt.iloc[-1] - df_time_nonzerocrnt.iloc[-1])/pd.Timedelta(1, 'min') > 30):
                                        if (len(df_nonzerocrnt_st) == 0):#放电前的静置过程无电流
                                            df_sor_cal = data.loc[(pd.to_datetime(data['时间戳']) >= df_time_zerocrnt.iloc[-1]) & (pd.to_datetime(data['时间戳']) < df_time_zerocrnt.iloc[-1] + datetime.timedelta(minutes = 15))]#筛选首次放电前的数据
                                            df_sor_result_temp = sor_cal_prog(df_sor_cal)
                                            df_sor_result = df_sor_result.append(df_sor_result_temp)
                                            df_sor_result.reset_index(drop = True, inplace = True)
                                        if df_dschrg_data['总电流[A]'].iloc[rest_dschrg_pos[0][item] + 1] == 0:#放电阶段首个采样时刻无电流时，需选取放电过程中有电流的时间段
                                            df_dschrg_item_temp = df_dschrg_data.iloc[(rest_dschrg_pos[0][item] + 1):rest_dschrg_pos[0][item + 1]]#放电数据
                                            df_dschrg_item = df_dschrg_item_temp.reset_index(drop = True)
                                            df_dschrg_crnt_data = df_dschrg_item.loc[df_dschrg_item['总电流[A]'] != 0]#有电流数据
                                            if len(df_dschrg_crnt_data) > 0:
                                                np_frst_crnt_pos = df_dschrg_crnt_data[df_dschrg_crnt_data['时间戳'] == df_dschrg_crnt_data['时间戳'].iloc[0]].index.tolist()#首个出现电流点
                                                np_frst_crnt_time = pd.to_datetime(df_dschrg_item['时间戳'].iloc[np_frst_crnt_pos[0] - 1])
                                                df_sor_cal = data.loc[(pd.to_datetime(data['时间戳']) >= np_frst_crnt_time) & (pd.to_datetime(data['时间戳']) < np_frst_crnt_time + datetime.timedelta(minutes = 15))]#筛选首次放电前的数据
                                                df_sor_result_temp = sor_cal_prog(df_sor_cal)
                                                df_sor_result = df_sor_result.append(df_sor_result_temp)
                                                df_sor_result.reset_index(drop = True, inplace = True)
                        end_caltime = time.time()
                        print(end_caltime - st_caltime)
        end_time = time.time()
        print(end_time - start_time)
        if not df_sor_result.empty:
            return df_sor_result
        else:
            return pd.DataFrame()
