from ctypes import Structure
from re import M
import pandas as pd
import numpy as np
import datetime
import time, datetime
import matplotlib.pyplot as plt
from pylab import*
from scipy.signal import savgol_filter
from scipy import interpolate
import os
from LIB.MIDDLE.CellStateEstimation.Common.V1_0_1 import BatParam
class cell_statistic:
    def __init__(self,sn,celltype,df_bms):  #参数初始化
        self.sn=sn
        self.celltype=celltype
        self.param=BatParam.BatParam(celltype)#鹏飞param中为BatParam，学琦为BatteryInfo
        self.df_bms=pd.DataFrame(df_bms)
        self.packcrnt=df_bms['总电流[A]']*self.param.PackCrntDec
        self.packvolt=df_bms['总电压[V]']
        self.bms_soc=df_bms['SOC[%]']
        self.bmstime= pd.to_datetime(df_bms['时间戳'], format='%Y-%m-%d %H:%M:%S')
        self.LookTab_OCV = self.param.LookTab_OCV
        self.LookTab_SOC = self.param.LookTab_SOC
        self.packcrnt_flg = self.param.PackCrntDec#判断充放电电流方向，一般放电为正，充电为负
        self.cellvolt_list=['单体电压'+str(x) for x in range(1,self.param.CellVoltNums+1)]
        self.celltemp_name=['单体温度'+str(x) for x in range(1,self.param.CellTempNums+1)]
        self.bmssta = df_bms['充电状态']
    #定义加权滤波函数..................................................................................................
    def moving_average(interval, windowsize):
        window = np.ones(int(windowsize)) / float(windowsize)
        re = np.convolve(interval, window, 'same')
        return re
#.............................................充电行为统计............................................................................
    def chrgr_sta(self):
        start_time = time.time()
        df_chrgr_soc = pd.DataFrame(columns = ['sn', 'time_st', 'time_end', 'soc_st', 'soc_sp', 'delta_soc', 'temp_st', 'temp_sp','meancrnt'])
        data_temp = self.df_bms
        data_temp = data_temp.dropna(axis = 0, how = 'any', subset = ['总电流[A]', 'SOC[%]'])#删除电流与SOC中的nan值
        data_temp.reset_index(inplace = True, drop = True)
        data = data_temp.copy()
        data['总电流[A]'] = self.param.PackCrntDec*data_temp['总电流[A]']
        #----------------------------------------区分充放电数据----------------------------------------------------------------------
        df_soc = data['SOC[%]']
        df_soc[df_soc > 98] = 100#满SOC
        #-------------------------------------------------------利用电流连续为负及SOC升高判断充电---------------------------------------------------------
        chrgr_crnt = data.loc[data['总电流[A]'] > 0]#电流为放电电流的数据
        if not chrgr_crnt.empty:
            chrgr_crnt_data = chrgr_crnt.reset_index(drop=True)
            temp_chrgr_time = chrgr_crnt_data['时间戳']
            chrgr_time = pd.to_datetime(temp_chrgr_time)
            delta_time = (np.diff(chrgr_time)/pd.Timedelta(1, 'min'))#计算时间差的分钟数
            pos = np.where(delta_time > 10)#充电数据分段,大于10min时，认为是两个静置过程
            splice_num = []
            if len(pos[0]) >= 1:
                pos_ful_tem = np.insert(pos, 0, 0)
                pos_len = len(pos_ful_tem)
                data_len = len(chrgr_time)
                pos_ful = np.insert(pos_ful_tem, pos_len, data_len-1)
                for item in range(0,len(pos_ful)-1):
                    splice_num.extend(item*np.ones(pos_ful[item +1]-pos_ful[item]))
                splice_num = np.insert(splice_num, 0, 0)
            else:
                splice_num = np.zeros(len(temp_chrgr_time))
                pos_ful = np.array([0])
            chrgr_crnt_data['chrgr_rest'] = splice_num
            if len(splice_num) > 0:
                chrgr_splice_num = np.unique(chrgr_crnt_data['chrgr_rest'])#判断有几段放电数据
                if len(chrgr_splice_num) > 0:
                    for item_chrgr in chrgr_splice_num:
                        celltemp_name = self.celltemp_name#电芯温度数量
                        df_chrgr_splice_data = chrgr_crnt_data.loc[chrgr_crnt_data['chrgr_rest'] == item_chrgr]
                        df_time_temp = pd.to_datetime(df_chrgr_splice_data['时间戳'])
                        df_soc_temp = df_chrgr_splice_data['SOC[%]']
                        delta_soc = round((df_soc_temp.iloc[-1] - df_soc_temp.iloc[0]), 3)
                        delta_time = (df_time_temp.iloc[-1] - df_time_temp.iloc[0])/pd.Timedelta(1, 'hours')
                        if delta_soc < -5:
                            chrg_rate = round(delta_soc/(100*delta_time), 2)
                            df_chrgr_soc_temp = pd.DataFrame({"sn":[self.sn], "time_st":[df_time_temp.iloc[0]], "time_end":[df_time_temp.iloc[-1]], 
                                                    "soc_st":[df_soc_temp.iloc[0]], "soc_sp":[df_soc_temp.iloc[-1]], "delta_soc":[delta_soc],
                                                    "temp_st":[str(list(df_chrgr_splice_data[celltemp_name].iloc[0]))], 
                                                    "temp_sp":[str(list(df_chrgr_splice_data[celltemp_name].iloc[-1]))],
                                                    "meancrnt":[chrg_rate]})
                            df_chrgr_soc = df_chrgr_soc.append(df_chrgr_soc_temp)
                            df_chrgr_soc.reset_index(drop = True, inplace = True)
                        # df_chrgr_soc.sort_values(by = ['splicestrt_time'], axis = 0, ascending=True,inplace=True)#对故障信息按照时间进行排序
        if not df_chrgr_soc.empty:
            return df_chrgr_soc
        else:
            return pd.DataFrame()
