import datetime
import pandas as pd
from LIB.BACKEND import DBManager, Log
import time, datetime
from apscheduler.schedulers.blocking import BlockingScheduler
import log
from pandas.core.frame import DataFrame
import rest_stscs_v1
import soc_total

#...................................电池包电芯安全诊断函数......................................................................................................................
def rest_statics():
    global SNnums
    global df_rest_static
    start=time.time()
    now_time=datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    now_time=datetime.datetime.strptime(now_time,'%Y-%m-%d %H:%M:%S')
    start_time=now_time-datetime.timedelta(days=3)
    end_time=str(now_time)
    start_time=str(start_time)
    k = 602
    for sn in SNnums[k:]:
        if 'PK500' in sn:
            celltype=1 #6040三元电芯
        elif 'PK502' in sn:
            celltype=2 #4840三元电芯
        elif 'K504B' in sn:
            celltype=99    #60ah林磷酸铁锂电芯
        elif 'MGMLXN750' in sn:
            celltype=3 #力信50ah三元电芯
        elif 'MGMCLN750' in sn: 
            celltype=4 #CATL 50ah三元电芯
        elif 'UD' in sn:
            celltype=4 #CATL 50ah三元电芯
        elif 'TJMCL' in sn: 
            celltype=100 #金茂电芯
        else:
            print('SN：{}，未找到对应电池类型！！！'.format(sn))
            continue
            # sys.exit()
        print('计算的第' + str(k) + '个:' + sn)
        k = k + 1
        #读取原始数据库数据........................................................................................................................................................
        start_time = '2021-06-01 00:00:00'
        end_time = '2021-07-01 00:00:00'
        dbManager = DBManager.DBManager()
        df_data = dbManager.get_data(sn=sn, start_time=start_time, end_time=end_time, data_groups=['bms'])
        df_bms = df_data['bms']
        df_Diag_rest_add = pd.DataFrame(columns = ['sn', 'time_st', 'time_end', 'soc_st', 'soc_sp', 'delta_soc', 'tempure', 'meancrnt'])
        #充电统计................................................................................................................................................................
        if not df_bms.empty:
            rest_statics_temp = rest_stscs_v1.cell_statistic(sn,celltype,df_bms)#析锂检测
            df_Diag_rest_add = rest_statics_temp.rest_sta()        
        if not df_Diag_rest_add.empty:
            df_rest_static = df_rest_static.append(df_Diag_rest_add)
            df_rest_static = df_rest_static.drop_duplicates(subset = ['sn','time_st'], keep = 'first', inplace = False)
            # df_rest_static.sort_values(by = ['sn'], axis = 0, ascending=True,inplace=True)#对故障信息按照时间进行排序
            df_rest_static.to_csv(r'D:\Develop\User\Liuzhongxiao\data_analyze_platform\USER\LZX\01算法开发\08合众算法开发\01静置统计\静置统计.csv',index=False,encoding='GB18030')
        end=time.time()
        print(end-start)

#...............................................主函数.......................................................................................................................
if __name__ == "__main__":
    global SNnums
    global df_rest_static
    
    excelpath=r'D:\Develop\User\Liuzhongxiao\data_analyze_platform\USER\LZX\01算法开发\00项目sn号\sn-20210903.xlsx'
    SNdata_6060 = pd.read_excel(excelpath, sheet_name='科易6060')
    SNdata_6040 = pd.read_excel(excelpath, sheet_name='科易6040')
    SNdata_4840 = pd.read_excel(excelpath, sheet_name='科易4840')
    SNdata_L7255 = pd.read_excel(excelpath, sheet_name='格林美-力信7255')
    SNdata_C7255 = pd.read_excel(excelpath, sheet_name='格林美-CATL7255')
    SNdata_U7255 = pd.read_excel(excelpath, sheet_name='优旦7255')
    SNnums_6060=SNdata_6060['SN号'].tolist()
    SNnums_6040=SNdata_6040['SN号'].tolist()
    SNnums_4840=SNdata_4840['SN号'].tolist()
    SNnums_L7255=SNdata_L7255['SN号'].tolist()
    SNnums_C7255=SNdata_C7255['SN号'].tolist()
    SNnums_U7255=SNdata_U7255['SN号'].tolist()
    # SNums_file = pd.read_csv(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\02析锂检测\02析锂分析\各项目析锂情况_211130\增加波峰高度与峰谷比计算结果\SNnums_C7255析锂情况析锂排序.csv',encoding='GB18030')
    # SNums_sn = SNums_file['sn']
    # liplated_high = SNums_sn.iloc[7:10]
    # liplated_low = SNums_sn.iloc[-11:-1]
    # cal_sn = liplated_high.append(liplated_low)
    SNnums = SNnums_L7255[50:] + SNnums_C7255[50:] + SNnums_6040[50:] + SNnums_4840[50:] + SNnums_U7255[50:]+ SNnums_6060[50:]
    # SNnums = SNnums_U7255
    # SNnums=['TJMCL120502305010','TJMCL120502305012','TJMCL120502305048','TJMCL120502305044','TJMCL120502305026','TJMCL120502305022','TJMCL120502305032','TJMCL120502305038']
    # SNnums = list(cal_sn)#['MGMCLN750N215N049']#['MGMCLN750N215N049'] #SNnums_6040 #SNnums_C7255 #SNnums_6040['MGMCLN750N215N049'] 
    # SNnums = pd.read_csv(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\02析锂检测\liplated\疑似析锂电池sn.csv',encoding='GB18030')
    # SNnums=['TJMCL120502305010','TJMCL120502305012','TJMCL120502305048','TJMCL120502305044','TJMCL120502305026','TJMCL120502305022','TJMCL120502305032','TJMCL120502305038']
    mylog=log.Mylog('log_diag.txt','error')#'TJMCL120502305010','TJMCL120502305012',
    mylog.logcfg()
    #............................模块运行前，先读取数据库中所有结束时间为0的数据，需要从数据库中读取................
    df_rest_static = pd.read_csv(r'D:\Develop\User\Liuzhongxiao\data_analyze_platform\USER\LZX\01算法开发\08合众算法开发\01静置统计\静置统计.csv',encoding='GB18030')

    print('----------------输入--------')
    print('-------计算中-----------')
    rest_statics()
    #定时任务.......................................................................................................................................................................
    # scheduler = BlockingScheduler()
    # scheduler.add_job(rest_statics, 'interval', seconds=10, id='diag_job')

    # try:  
    #     scheduler.start()
    # except Exception as e:
    #     scheduler.shutdown()
    #     print(repr(e))
    #     mylog.logopt(e)

