from ctypes import Structure
from re import M
import pandas as pd
import numpy as np
import datetime
import time, datetime
import matplotlib.pyplot as plt
from pylab import*
from scipy.signal import savgol_filter
from scipy import interpolate
import os
from LIB.MIDDLE.CellStateEstimation.Common.V1_0_1 import BatParam
class cell_statistic:
    def __init__(self,sn,celltype,df_bms):  #参数初始化
        self.sn=sn
        self.celltype=celltype
        self.param=BatParam.BatParam(celltype)#鹏飞param中为BatParam，学琦为BatteryInfo
        self.df_bms=pd.DataFrame(df_bms)
        self.packcrnt=df_bms['总电流[A]']*self.param.PackCrntDec
        self.packvolt=df_bms['总电压[V]']
        self.bms_soc=df_bms['SOC[%]']
        self.bmstime= pd.to_datetime(df_bms['时间戳'], format='%Y-%m-%d %H:%M:%S')
        self.LookTab_OCV = self.param.LookTab_OCV
        self.LookTab_SOC = self.param.LookTab_SOC
        self.packcrnt_flg = self.param.PackCrntDec#判断充放电电流方向，一般放电为正，充电为负
        self.cellvolt_list=['单体电压'+str(x) for x in range(1,self.param.CellVoltNums+1)]
        self.celltemp_name=['单体温度'+str(x) for x in range(1,self.param.CellTempNums+1)]
        self.bmssta = df_bms['充电状态']
    #定义加权滤波函数..................................................................................................
    def moving_average(interval, windowsize):
        window = np.ones(int(windowsize)) / float(windowsize)
        re = np.convolve(interval, window, 'same')
        return re
    
#.............................................静置行为统计............................................................................
    def rest_sta(self):
        def clean_dead_value(series, num_dead_thresh):
            slide_list = [series.index[0]]
            slide_list_all = []
            for i in range(series.index[0],series.index[-1]):
                j = i + 1
                diff = series[j] - series[i]
                if diff == 0:
                    slide_list.append(j)
                else:
                    slide_list.clear()
                    slide_list.append(j)
                # print("slide_list:",slide_list)
                if len(slide_list) >= num_dead_thresh:
                    target_list = slide_list.copy()
                    slide_list_all.append(target_list)
            # print("slide_list_all:",slide_list_all)
            index= []  # 将找到的满足条件的index合并
            # 因为可能有前后包含的情况，只保留最长序列
            for i in range(len(slide_list_all) - 1):
                if set(slide_list_all[i]) < set(slide_list_all[i + 1]):
                    index.append(i)
            m = {i: element for i, element in enumerate(slide_list_all)}
            [m.pop(i) for i in index]
            # 将所有需要删除的行数合并
            # indexs_to_delete = []
            # for i in range(len(slide_list_all)):
            #     indexs_to_delete = list(set(indexs_to_delete).union(slide_list_all[i]))
            return list(m.values())
        df_rest_soc = pd.DataFrame(columns = ['sn', 'time_st', 'time_end', 'soc_st', 'soc_sp', 'delta_soc', 'tempure', 'meancrnt'])
        data_temp = self.df_bms
        data = data_temp.dropna(axis = 0, how = 'any', subset = ['总电流[A]', 'SOC[%]'])#删除电流与SOC中的nan值
        #----------------------------------------区分充放电数据----------------------------------------------------------------------
        # df_crnt = data['总电流[A]']
        # df_soc[df_soc > 98] = 100#满SOC
        #-------------------------------------------------------利用电流连续为0判断电池静置---------------------------------------------------------
        rest_crnt = data.loc[data['总电流[A]'] == 0]#电流为0，判断电池静置
        if not rest_crnt.empty:
            df_crnt = data['总电流[A]']
            num_dead_thresh = 12#判断连续多少个数据为阈值
            # series = df.iloc[:,0]  #仅作为示例，如果是多列，可以进行循环
            indexs_to_delelte = clean_dead_value(df_crnt, num_dead_thresh)#获得连续数据所在的行
            rest_num = len(indexs_to_delelte)
            for splice_item in range(0, rest_num):#
                print('第' + str(splice_item) + '个片段')
                start_time = time.time()
                df_data_temp = pd.DataFrame()
                df_rest_soc_temp = pd.DataFrame(columns = ['sn', 'time_st', 'time_end', 'soc_st', 'soc_sp', 'delta_soc', 'tempure', 'meancrnt'])
                df_data_temp = data.iloc[indexs_to_delelte[splice_item][0]:indexs_to_delelte[splice_item][-1]]#获得电流连续数据
                df_time_temp = pd.to_datetime(df_data_temp['时间戳'])
                if all(df_data_temp['总电流[A]'] == 0):
                    delta_time = (df_time_temp.iloc[-1] - df_time_temp.iloc[0])/pd.Timedelta(1, 'hours')
                    if delta_time > 1:
                        celltemp_name = self.celltemp_name#电芯温度数量
                        df_soc_temp = df_data_temp['SOC[%]']
                        delta_soc = round((df_soc_temp.iloc[-1] - df_soc_temp.iloc[0]), 3)
                        # delta_time = (df_time_temp.iolc[-1] - df_time_temp.iloc[0])/pd.Timedelta(1, 'hours')
                        chrg_rate = round(delta_soc/(100*delta_time), 2)
                        df_rest_soc_temp = pd.DataFrame({"sn":[self.sn], "time_st":[df_time_temp.iloc[0]], "time_end":[df_time_temp.iloc[-1]], 
                                                "soc_st":[df_soc_temp.iloc[0]], "soc_sp":[df_soc_temp.iloc[-1]], "delta_soc":[delta_soc],
                                                "tempure":[str(list(df_data_temp[celltemp_name].iloc[0]))], "meancrnt":[chrg_rate]})
                        df_rest_soc = df_rest_soc.append(df_rest_soc_temp)
                        df_rest_soc.reset_index(drop = True, inplace = True)
                        end_time = time.time()
                        print(end_time - start_time)
                        # df_rest_soc.sort_values(by = ['splicestrt_time'], axis = 0, ascending=True,inplace=True)#对故障信息按照时间进行排序
        if not df_rest_soc.empty:
            return df_rest_soc
        else:
            return pd.DataFrame()
